package Chapter21;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.Random;
import javax.imageio.ImageIO;
import javax.swing.JPanel;
import javax.swing.Timer;

class MarksmanGUI extends javax.swing.JFrame {

    int mouseX, mouseY;

    public MarksmanGUI() {
        initComponents();
    }

    private void initComponents() {

        rangeTextField = new javax.swing.JTextField();
        rangeLabel = new javax.swing.JLabel();
        convertButton = new javax.swing.JButton();
        TargetPanel = new ShooterPanel();
        windspeedLabel = new javax.swing.JLabel();
        windspeedTextField = new javax.swing.JTextField();
        windDirectionTextField = new javax.swing.JTextField();
        windDirectionLabel = new javax.swing.JLabel();
        muzzelVelocityTextField = new javax.swing.JTextField();
        muzzelVelocityLabel = new javax.swing.JLabel();
        ballisticCoefficientTextField = new javax.swing.JTextField();
        ballisticCoefficientLabel = new javax.swing.JLabel();
        windDragCoefficent = new javax.swing.JTextField(); 
        windDragCoefficentLabel = new javax.swing.JLabel(); 
        bulletMass = new javax.swing.JTextField(); 
        bulletMassLabel = new javax.swing.JLabel();
        zoomSelect = new javax.swing.JSpinner();
        zoomSelectLabel = new javax.swing.JLabel();
        windageSelect = new javax.swing.JSpinner(); 
        windageSelectLabel = new javax.swing.JLabel();
        elevationSelect = new javax.swing.JSpinner();
        elevationSelectLabel = new javax.swing.JLabel();
        

        timer = new Timer(100, TargetPanel);
        timer.start();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Marksman Simulation");

        rangeLabel.setText("Range to Target in meters");
        windDirectionLabel.setText("Wind Direction in degrees from headwind, 90 is blowing right to left");
        windspeedLabel.setText("Wind Speed in meters per second");
        muzzelVelocityLabel.setText("Muzzel Velocity in meters per second");
        ballisticCoefficientLabel.setText("Ballistic Coefficient for specific bullet");
        windDragCoefficentLabel.setText("Wind drag coefficent");
        bulletMassLabel.setText("Bullet mass in grains");
        zoomSelectLabel.setText("Select Zoom");
        windageSelectLabel.setText("Select # of windage clicks");
        elevationSelectLabel.setText("Select # of elevation clicks");
        
        rangeTextField.setText("10");
        windspeedTextField.setText("10");
        windDirectionTextField.setText("90");
        muzzelVelocityTextField.setText("1234");
        ballisticCoefficientTextField.setText(".79");
        windDragCoefficent.setText("0.5");
        bulletMass.setText("10");

        convertButton.setText("Apply Changes");
        
        zoomSelect.setModel(new javax.swing.SpinnerNumberModel(1, 1, 20, 5));
        windageSelect.setModel(new javax.swing.SpinnerNumberModel(0, -50, 50, 1));
        elevationSelect.setModel(new javax.swing.SpinnerNumberModel(0, -50, 50, 1));

        convertButton.addActionListener(new java.awt.event.ActionListener() {

            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                convertButtonActionPerformed(evt);
            }
        });

        TargetPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        TargetPanel.setCursor(new java.awt.Cursor(java.awt.Cursor.CROSSHAIR_CURSOR));

        TargetPanel.addMouseListener(new java.awt.event.MouseAdapter() {

            @Override
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                TargetPanelMouseClicked(evt);
            }

            @Override
            public void mousePressed(java.awt.event.MouseEvent evt) {
                TargetPanelMousePressed(evt);
            }

            @Override
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                TargetPanelMouseReleased(evt);
            }
        });

        TargetPanel.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

            @Override
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                TargetPanelMouseMoved(evt);
            }
        });


        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(TargetPanel);

        TargetPanel.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jPanel1Layout.createSequentialGroup().addGap(79, 79, 79)
                .addContainerGap(80, Short.MAX_VALUE)));
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jPanel1Layout.createSequentialGroup().addContainerGap()
                .addContainerGap(20, Short.MAX_VALUE)));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(rangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(rangeLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(bulletMass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bulletMassLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(windspeedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(windspeedLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(windDirectionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(windDirectionLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(windDragCoefficent, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(windDragCoefficentLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(muzzelVelocityTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(muzzelVelocityLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ballisticCoefficientTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ballisticCoefficientLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(zoomSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(zoomSelectLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(windageSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(windageSelectLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(elevationSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(elevationSelectLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(convertButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGap(97, 97, 97)))
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addContainerGap(56, Short.MAX_VALUE)
                        .addComponent(TargetPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(59, Short.MAX_VALUE)));

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[]{convertButton, rangeTextField, windspeedTextField, windDirectionTextField, windDragCoefficent, muzzelVelocityTextField, ballisticCoefficientTextField, bulletMass});

        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(rangeLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bulletMass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bulletMassLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)               
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(windspeedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(windspeedLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(windDirectionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(windDirectionLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(windDragCoefficent, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(windDragCoefficentLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(muzzelVelocityTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(muzzelVelocityLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ballisticCoefficientTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ballisticCoefficientLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(zoomSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(zoomSelectLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(windageSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(windageSelectLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(elevationSelect, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(elevationSelectLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(convertButton).addComponent(windspeedLabel))
                .addGap(27, 27, 27)
                    .addComponent(TargetPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(22, Short.MAX_VALUE)));
        pack();

    }

    private void convertButtonActionPerformed(java.awt.event.ActionEvent evt) {
        double v, r, d, m, Cw, bw, bd;
        int zm, windage, elevation;

        
        r = (Double.parseDouble(rangeTextField.getText()));
        v = (Double.parseDouble(windspeedTextField.getText()));
        d = (Double.parseDouble(windDirectionTextField.getText()));
        m = (Double.parseDouble(muzzelVelocityTextField.getText()));
        Cw = (Double.parseDouble(windDragCoefficent.getText()));
        bw = (Double.parseDouble(bulletMass.getText()));
        bd = (Double.parseDouble(ballisticCoefficientTextField.getText()));
        zm = (int) zoomSelect.getValue();
        windage = (int) windageSelect.getValue();
        elevation = (int) elevationSelect.getValue();

        TargetPanel.setEnviroment(r, v, d, m, Cw, bw, bd, zm, windage, elevation);
    }

    private void TargetPanelMouseClicked(java.awt.event.MouseEvent evt) {
        if (evt.getButton() == java.awt.event.MouseEvent.BUTTON1) {
            TargetPanel.setHole();
            repaint();
        }
    }

    private void TargetPanelMousePressed(java.awt.event.MouseEvent evt) {
        if (evt.getButton() == java.awt.event.MouseEvent.BUTTON3) {
            TargetPanel.setBreathing(false);
        }
    }

    private void TargetPanelMouseReleased(java.awt.event.MouseEvent evt) {
        if (evt.getButton() == java.awt.event.MouseEvent.BUTTON3) {
            TargetPanel.setBreathing(true);
        }
    }

    private void TargetPanelMouseMoved(java.awt.event.MouseEvent evt) {
        TargetPanel.setAim(evt.getX(), evt.getY());
        repaint();
    }

    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MarksmanGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new MarksmanGUI().setVisible(true);
            }
        });


    }
    private javax.swing.JLabel rangeLabel;
    private javax.swing.JButton convertButton;
    public ShooterPanel TargetPanel;
    private javax.swing.JLabel windspeedLabel;
    private javax.swing.JLabel targetImage;
    private javax.swing.JTextField rangeTextField;
    private javax.swing.JTextField windspeedTextField;
    private javax.swing.JTextField windDirectionTextField;
    private javax.swing.JLabel windDirectionLabel;
    private javax.swing.JTextField muzzelVelocityTextField;
    private javax.swing.JLabel muzzelVelocityLabel;
    private javax.swing.JTextField ballisticCoefficientTextField;
    private javax.swing.JLabel ballisticCoefficientLabel;
    private javax.swing.JTextField windDragCoefficent ;
    private javax.swing.JLabel windDragCoefficentLabel;
    private javax.swing.JTextField bulletMass;
    private javax.swing.JLabel bulletMassLabel;
    private javax.swing.JSpinner zoomSelect; 
    private javax.swing.JLabel zoomSelectLabel;
    private javax.swing.JSpinner windageSelect; 
    private javax.swing.JLabel windageSelectLabel;
    private javax.swing.JSpinner elevationSelect;
    private javax.swing.JLabel elevationSelectLabel;
    
    public Timer timer;
}

class ShooterPanel extends JPanel implements ActionListener {
    
    //<editor-fold defaultstate="collapsed" desc="Class Variables">
    private int aimX, aimY, holeX, holeY;
    private double range = 10, windspeed = 10, windDirection = 90;
    private double muzzelVelocity = 1043.94; //meters per second
    private double timeOfFlight;
    private double alpha = 90;
    private double baseElevation;
    private double windDragCo=0.5;
    private double bulletW = 180; //bullet weight in grains
    private double bulletDrag = 0.5;
    private boolean breathing = true;
    private int breathHeight = -1;
    private boolean direction = true;
    private int drawH, drawW, zoom=1;
    private double targetH=1.0, targetW=1.0, viewerDist=0.6;
    private double pxPM;
    SimulationTask sim;
    private int status = 0;
    Random generator = new Random(1231212451);
    private double windage = 0; 
    private double elevation = 0;
    //</editor-fold>
    
    ShooterPanel() {
        // set a preferred size for the custom panel.
        setPreferredSize(new Dimension(400, 400));
        drawH = (int)((((2*((targetH/2)/range)*viewerDist))/0.0002825)*zoom); //TODO:PIXEL CONVERSION?
        drawW = (int)((((2*((targetW/2)/range)*viewerDist))/0.0002825)*zoom);
    }

    public void setEnviroment(double r, double v, double d, double m, double Cw, double bw, double bd, int zm, double wg, double elv) {
        range = r;
        zoom = zm;
        windspeed = v;
        windDirection = d;
        muzzelVelocity = m;
        windDragCo = Cw;
        bulletW = bw * 0.0647981/1000; //convert to kilograms
        bulletDrag = bd;
        bulletW = .1; //TODO
        targetH = 1.0;
        targetW = 1.0;
        pxPM = 0.0002825; //meters per pixel
        drawH = (int)((((2*((targetH/2)/range)*viewerDist))/pxPM)*zoom); //TODO:PIXEL CONVERSION?
        System.out.println("height in px: " + drawH);
        drawW = (int)((((2*((targetW/2)/range)*viewerDist))/pxPM)*zoom);
        windage = wg; 
        elevation = elv;

    }

    public void setAim(int x, int y) {
        aimX = x;
        aimY = y;
    }

    public void setBreathing(boolean ans) {
        breathing = ans;
    }

    //Manipulate the point of aim   
    @Override
    public void actionPerformed(ActionEvent e) {

        //<editor-fold defaultstate="collapsed" desc="Adjust aim for breathing">
        if (direction == true) {
            breathHeight = breathHeight + 1;
            if (breathHeight == 5) {
                direction = false;
                breathHeight = breathHeight + 1;
            }
        }

        if (direction == false) {
            breathHeight = breathHeight - 1;
            if (breathHeight == -5) {
                direction = true;
            }
        }

        if (breathing) {
            aimY = aimY + breathHeight;
        }
        //</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="Adjust aim for steadyness">
        //TODO: Adjust x and y coordinate of aim for steadyness
        //</editor-fold>

        repaint();
    }

    public void setHole() {

        //<editor-fold defaultstate="collapsed" desc="Adjust aim for recoil">
       
        //</editor-fold>

        //Calculation Alpha and Gamma from aim
        double alp, gmm;

        alp = 90-Math.toDegrees(Math.atan(((200-aimY)*(targetH/(drawH)))/range)); //somethign wrong here
        gmm = Math.toDegrees(Math.atan(((200-aimX)*(targetH/(drawH)))/range)); //something wrong here
        
        System.out.println("Alp w/o elevatoin:" + alp);
        System.out.println("Elevation: " + (elevation/60));
        alp = alp - (elevation/60);
        System.out.println("Alp w/ elevatoin:" + alp);
        gmm = gmm - (windage/60);
                
        status = 0;

        //<editor-fold defaultstate="collapsed" desc="Simulation Setup and Loop">
        sim = new SimulationTask();
        sim.setupWind(windspeed, windDirection, windDragCo);
        sim.setupAmmo(muzzelVelocity, bulletW, bulletDrag);
        sim.setupGun(alp, gmm, 2.0, 0.2);
        sim.setupTarget(range+(10.0/2), 2.0, 0.0, 10.0, 1.0, 1.0); //don't forget to add 1/2 thickness
        while (status == 0) {
            status = sim.doSimulation();
            //System.out.println(sim.x() + "," + sim.y() + "," + sim.z());
                
            if (sim.x() > range+2){
                status = -1;
                break; 
            }
        }
        //</editor-fold>
        
        if (status == 1) {
            holeX = 200 - (int) ((sim.z() * (drawH / (targetH))));
            holeY = 200 - (int) ((sim.y() - 2.0) * (drawH / (targetH)));
        }
        
        else {
            holeX = 500;
            holeY = 500;
        }
        //Adjust for Recoil 
        System.out.println("Status= " + status);
        
    }

    @Override
    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        BufferedImage targetImg = null;
        URL url = MarksmanGUI.class.getResource("target.jpg");
        try {
            targetImg = ImageIO.read(url);
        } catch (IOException e) {
            System.out.println("Image file not found.");
        }

        super.paintComponent(g);
        g2.drawImage(targetImg, (int)(200-(drawH/2)), (int)(200-(drawH/2)), drawH, drawW, null);
        g2.drawOval(aimX-5, aimY-5, 10, 10);
        g2.fillOval(holeX-5, holeY-5, 10, 10);

    }
}

class SimulationTask {
    
    //<editor-fold defaultstate="collapsed" desc="SimulationTask Variables">
    
    
    double Vm;		// Magnitude of muzzle velocity
    double Alpha;	// Angle from y-axis (upward) to the cannon.
                        // When this angle is zero the cannon is pointing
                        // straight up, when it is 90 degrees, the cannon
                        // is horizontal
    double Gamma;	// Angle from x-axis, in the x-z plane to the cannon.
                        // When this angle is zero the cannon is pointing in
                        // the positive x-direction, positive values of this angle
                        // are toward the positive z-axis
    double L;		// This is the length of the cannon
    double Yb;		// This is the base elevation of the cannon
    double X;		// The x-position of the center of the target
    double Y;		// The y-position of the center of the target
    double Z;		// The z-position of the center of the target
    double Length;	// The length of the target measured along the x-axis
    double Width;	// The width of the target measured along the z-axis
    double Height;      // The height of the target measure along the y-axis
    TVector s;		// The shell position (displacement) vector
    double time;	// The time from the instant the shell leaves the cannon
    double tInc;	// The time increment to use when stepping through the simulation
    double g = 9.81;	// acceleration due to gravity
    //-------------------------------------------------------------------//
    // New variables:
    double m;      // Projectile mass
    double Vw;     // Wind speed 
    double GammaW; // Wind direction
    double Cw;     // Wind force coefficient
    double Cd;     // Drag coefficient
    //</editor-fold>    
    
    class TVector {

        double i;
        double j;
        double k;
    }

    SimulationTask() {
        time = 0;
        tInc = .0001;
        s = new TVector();
    }

    void setupAmmo(double Vmuz, double mass, double cd) {
        Vm = Vmuz;
        m = mass;
        Cd = cd;
    }

    void setupGun(double al, double gm, double base, double barrl) {
        Alpha = al;
        Gamma = gm;
        Yb = base;
        L = barrl;
    }

    void setupTarget(double x, double y, double z, double l, double w, double h) {
        X = x;		// The x-position of the center of the target
        Y = y;		// The y-position of the center of the target
        Z = z;		// The z-position of the center of the target
        Length = l;	// The length of the target measured along the x-axis
        Width = w;	// The width of the target measured along the z-axis
        Height = h;     // The height of the target measure along the y-axis
    }

    void setupWind(double vm, double gw, double cw) {
        Vw = vm;     // Wind speed 
        GammaW = gw; // Wind direction
        Cw = cw;     // Wind force coefficient
    }

    int doSimulation() {
        
        double cosX;
        double cosY;
        double cosZ;
        double xe, ze;
        double b, Lx, Ly, Lz;
        double tx1, tx2, ty1, ty2, tz1, tz2;

        // new local variablels:
        double sx1, vx1;
        double sy1, vy1;
        double sz1, vz1;
        
        // step to the next time in the simulation
        time += tInc;
        
        // First calculate the direction cosines for the cannon orientation.
        // In a real game you would not want to put this calculation in this
        // function since it is a waste of CPU time to calculate these values
        // at each time step as they never change during the sim.  I only put them here in 
        // this case so you can see all the calculation steps in a single function.
        b = L * Math.cos((90 - Alpha) * 3.14 / 180);    // projection of barrel onto x-z plane
        Lx = b * Math.cos(Gamma * 3.14 / 180);		// x-component of barrel length
        Ly = L * Math.cos(Alpha * 3.14 / 180);		// y-component of barrel length
        Lz = b * Math.sin(Gamma * 3.14 / 180);          // z-component of barrel length

        cosX = Lx / L;
        cosY = Ly / L;
        cosZ = Lz / L;

        // These are the x and z coordinates of the very end of the cannon barrel
        // we'll use these as the initial x and z displacements
        xe = L * Math.cos((90 - Alpha) * 3.14 / 180) * Math.cos(Gamma * 3.14 / 180);
        ze = L * Math.cos((90 - Alpha) * 3.14 / 180) * Math.sin(Gamma * 3.14 / 180);

        // Now we can calculate the position vector at this time

        // Old position vector commented out:
        //s.i = Vm * cosX * time + xe;
        //s.j = (Yb + L * cos(Alpha*3.14/180)) + (Vm * cosY * time) - (0.5 * g * time * time);
        //s.k = Vm * cosZ * time + ze;

        // New position vector calc.:
        sx1 = xe;
        vx1 = Vm * cosX;

        sy1 = Yb + L * Math.cos(Alpha * 3.14 / 180);
        vy1 = Vm * cosY;

        sz1 = ze; 
        vz1 = Vm * cosZ;

        s.i = ((m / Cd) * Math.exp(-(Cd * time) / m) * ((-Cw * Vw * Math.cos(GammaW * 3.14 / 180)) / Cd - vx1)
                - (Cw * Vw * Math.cos(GammaW * 3.14 / 180) * time) / Cd)
                - ((m / Cd) * ((-Cw * Vw * Math.cos(GammaW * 3.14 / 180)) / Cd - vx1)) + sx1;

        s.j = sy1 + (-(vy1 + (m * g) / Cd) * (m / Cd) * Math.exp(-(Cd * time) / m) - (m * g * time) / Cd)
                + ((m / Cd) * (vy1 + (m * g) / Cd));

        s.k = ((m / Cd) * Math.exp(-(Cd * time) / m) * ((-Cw * Vw * Math.sin(GammaW * 3.14 / 180)) / Cd - vz1)
                - (Cw * Vw * Math.sin(GammaW * 3.14 / 180) * time) / Cd)
                - ((m / Cd) * ((-Cw * Vw * Math.sin(GammaW * 3.14 / 180)) / Cd - vz1)) + sz1;

        // Check for collision with target
        // Get extents (bounding coordinates) of the target
        tx1 = X - Length / 2;
        tx2 = X + Length / 2;
        ty1 = Y - Height / 2;
        ty2 = Y + Height / 2;
        tz1 = Z - Width / 2;
        tz2 = Z + Width / 2;

        // Now check to see if the shell has passed through the target
        // I'm using a rudimentary collision detection scheme here where
        // I simply check to see if the shell's coordinates are within the
        // bounding box of the target.  This works for demo purposes, but
        // a practical problem is that you may miss a collision if for a given
        // time step the shell's change in position is large enough to allow 
        // it to "skip" over the target.
        // A better approach is to look at the previous time step's position data
        // and to check the line from the previous postion to the current position
        // to see if that line intersects the target bounding box.
        if ((s.i >= tx1 && s.i <= tx2)
                && (s.j >= ty1 && s.j <= ty2)
                && (s.k >= tz1 && s.k <= tz2)) {
            return 1;
        }
        // Check for collision with ground (x-z plane)
        if (s.j <= 0) {
            return 2;
        }
        // Cutoff the simulation if it's taking too long
        // This is so the program does not get stuck in the while loop
        if (time > 36000) {
            return 3;
        }
        return 0;


    }
    
    double z(){
        return s.k; 
    }
    double y(){
        return s.j; 
    }
    double x(){
        return s.i;
    }
}
